#!/usr/bin/ruby
require 'gotham_dice'
require 'tty'

# number of times to test
ITERATIONS = 10_000

# all dice faces for gotham_dice
HEADERS    = ['pow', 'move', 'clue', 'totals']

bag = GothamDice.get
cup = bag.get_cup('combat', 'combat', 'detect', 'detect', 'move', 'move')

table = TTY::Table.new(header: HEADERS)
# totals = Hash.new{|h,k| h[k] = []}
totals = Hash.new(0)

ITERATIONS.times do
  r = cup.roll
  r['totals'] = r.values.reduce(:+)
  HEADERS.each do |h|
    totals[h] += r[h]
  end
end
puts totals.inspect
table << totals.values.map { |e| e * 1.0 / ITERATIONS }
puts table.render width: 120, resize: true
