require 'para_dice/die'
require 'para_dice/faces/ranged'
module ParaDice
  # a standard die like d6 d10, d20, d100 or exotic like d17, d32, d11-10, d100-999
  class NumberedDie
    include Die
    include Faces::Ranged

    # @!method initialize(params = {})
    #   initialize a new object, Inherited via Die from Virtus
    #   @params [Hash] params hash containing all data for object
    #     @option params params [String] :name

    # given a maximum value, return a NumberedDie with max faces from 1..max
    def self.get(max)
      self.new(name: "d#{max}", range: 1..max)
    end
  end
end
