require 'virtus' # TODO check on usage later

require 'para_dice/bag'
require 'para_dice/numbered_die'
require 'para_dice/results/number'
module ParaDice
  # A ParaDice bag that has all of the standard dice: d6, d10, d10, and that you
  # can add more like d33
  class PolyBag
    # contains all of the dice to start the bag with
    DEFAULT_DICE    = [2, 3, 4, 6, 8, 10, 12, 20, 30, 100]
    # the result stack that Bag will pass by default to cups.
    DEFAULT_READERS = [Results::Number]

    # generate a new poly bag with optional rng
    # @param [nil, Random, #rand] random number generator to pass to all cups
    #   (which will in turn pass it to each)
    # @return [PolyBag]
    def self.get(rng = nil)
      a = ParaDice::Bag.new(name:            'Poly Dice',
                            rng:             rng,
                            default_readers: DEFAULT_READERS)

      DEFAULT_DICE.each do |num|
        die = NumberedDie.get(num)
        a.add_die(die)
      end
      return a
    end
  end
end
