require 'para_dice/die'
require 'para_dice/faces/arrayed'

module ParaDice
  # A Simple die using an array of string faces
  # @see ParaDice::Die and ParaDice::Faces::StringArrayed
  class StringDie
    include ParaDice::Die
    include ParaDice::Faces::Arrayed

    # @!attribute [rw] description
    #   @return [String] defaults to a string like 'faces: foo, bar, baz'
    attribute :description, String, default: ->(s, a) { 'faces: ' + s.faces.join(', ') }
  end
end
